/* IOHelper.c generated by valac 0.44.3, the Vala compiler
 * generated from IOHelper.vala, do not modify */

/*-
 * Copyright (c) 2017-2018 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>

#define TYPE_IO_HELPER (io_helper_get_type ())
#define IO_HELPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IO_HELPER, IOHelper))
#define IO_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IO_HELPER, IOHelperClass))
#define IS_IO_HELPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IO_HELPER))
#define IS_IO_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IO_HELPER))
#define IO_HELPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IO_HELPER, IOHelperClass))

typedef struct _IOHelper IOHelper;
typedef struct _IOHelperClass IOHelperClass;
typedef struct _IOHelperPrivate IOHelperPrivate;
enum  {
	IO_HELPER_0_PROPERTY,
	IO_HELPER_NUM_PROPERTIES
};
static GParamSpec* io_helper_properties[IO_HELPER_NUM_PROPERTIES];

struct _IOHelper {
	GObject parent_instance;
	IOHelperPrivate * priv;
};

struct _IOHelperClass {
	GObjectClass parent_class;
};

static gpointer io_helper_parent_class = NULL;

GType io_helper_get_type (void) G_GNUC_CONST;
gboolean io_helper_is_valid_file_type (GFileInfo* file_info);
IOHelper* io_helper_new (void);
IOHelper* io_helper_construct (GType object_type);

static const gchar* IO_HELPER_ACCEPTED_TYPES[5] = {"image/jpeg", "image/png", "image/tiff", "image/svg+xml", "image/gif"};

gboolean
io_helper_is_valid_file_type (GFileInfo* file_info)
{
	gboolean result = FALSE;
#line 28 "../src/IOHelper.vala"
	g_return_val_if_fail (file_info != NULL, FALSE);
#line 30 "../src/IOHelper.vala"
	if (g_file_info_get_file_type (file_info) != G_FILE_TYPE_REGULAR) {
#line 31 "../src/IOHelper.vala"
		result = FALSE;
#line 31 "../src/IOHelper.vala"
		return result;
#line 75 "IOHelper.c"
	}
	{
		const gchar** type_collection = NULL;
		gint type_collection_length1 = 0;
		gint _type_collection_size_ = 0;
		gint type_it = 0;
#line 34 "../src/IOHelper.vala"
		type_collection = IO_HELPER_ACCEPTED_TYPES;
#line 34 "../src/IOHelper.vala"
		type_collection_length1 = G_N_ELEMENTS (IO_HELPER_ACCEPTED_TYPES);
#line 34 "../src/IOHelper.vala"
		for (type_it = 0; type_it < G_N_ELEMENTS (IO_HELPER_ACCEPTED_TYPES); type_it = type_it + 1) {
#line 88 "IOHelper.c"
			const gchar* type = NULL;
#line 34 "../src/IOHelper.vala"
			type = type_collection[type_it];
#line 92 "IOHelper.c"
			{
				const gchar* _tmp0_;
				const gchar* _tmp1_;
#line 35 "../src/IOHelper.vala"
				_tmp0_ = g_file_info_get_content_type (file_info);
#line 35 "../src/IOHelper.vala"
				_tmp1_ = type;
#line 35 "../src/IOHelper.vala"
				if (g_content_type_equals (_tmp0_, _tmp1_)) {
#line 36 "../src/IOHelper.vala"
					result = TRUE;
#line 36 "../src/IOHelper.vala"
					return result;
#line 106 "IOHelper.c"
				}
			}
		}
	}
#line 40 "../src/IOHelper.vala"
	result = FALSE;
#line 40 "../src/IOHelper.vala"
	return result;
#line 115 "IOHelper.c"
}

IOHelper*
io_helper_construct (GType object_type)
{
	IOHelper * self = NULL;
#line 18 "../src/IOHelper.vala"
	self = (IOHelper*) g_object_new (object_type, NULL);
#line 18 "../src/IOHelper.vala"
	return self;
#line 126 "IOHelper.c"
}

IOHelper*
io_helper_new (void)
{
#line 18 "../src/IOHelper.vala"
	return io_helper_construct (TYPE_IO_HELPER);
#line 134 "IOHelper.c"
}

static void
io_helper_class_init (IOHelperClass * klass,
                      gpointer klass_data)
{
#line 18 "../src/IOHelper.vala"
	io_helper_parent_class = g_type_class_peek_parent (klass);
#line 143 "IOHelper.c"
}

static void
io_helper_instance_init (IOHelper * self,
                         gpointer klass)
{
}

GType
io_helper_get_type (void)
{
	static volatile gsize io_helper_type_id__volatile = 0;
	if (g_once_init_enter (&io_helper_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (IOHelperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) io_helper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IOHelper), 0, (GInstanceInitFunc) io_helper_instance_init, NULL };
		GType io_helper_type_id;
		io_helper_type_id = g_type_register_static (G_TYPE_OBJECT, "IOHelper", &g_define_type_info, 0);
		g_once_init_leave (&io_helper_type_id__volatile, io_helper_type_id);
	}
	return io_helper_type_id__volatile;
}

