/* Appearance.c generated by valac 0.44.3, the Vala compiler
 * generated from Appearance.vala, do not modify */

/*
* Copyright (c) 2018 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#define TYPE_APPEARANCE (appearance_get_type ())
#define APPEARANCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APPEARANCE, Appearance))
#define APPEARANCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APPEARANCE, AppearanceClass))
#define IS_APPEARANCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APPEARANCE))
#define IS_APPEARANCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APPEARANCE))
#define APPEARANCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APPEARANCE, AppearanceClass))

typedef struct _Appearance Appearance;
typedef struct _AppearanceClass AppearanceClass;
typedef struct _AppearancePrivate AppearancePrivate;
enum  {
	APPEARANCE_0_PROPERTY,
	APPEARANCE_NUM_PROPERTIES
};
static GParamSpec* appearance_properties[APPEARANCE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block5Data Block5Data;

struct _Appearance {
	GtkGrid parent_instance;
	AppearancePrivate * priv;
};

struct _AppearanceClass {
	GtkGridClass parent_class;
};

struct _AppearancePrivate {
	GraniteWidgetsModeButton* text_size_modebutton;
};

struct _Block5Data {
	int _ref_count_;
	Appearance* self;
	GSettings* interface_settings;
};

static gint Appearance_private_offset;
static gpointer appearance_parent_class = NULL;

GType appearance_get_type (void) G_GNUC_CONST;
#define APPEARANCE_INTERFACE_SCHEMA "org.gnome.desktop.interface"
#define APPEARANCE_TEXT_SIZE_KEY "text-scaling-factor"
#define APPEARANCE_PANEL_SCHEMA "io.elementary.desktop.wingpanel"
#define APPEARANCE_TRANSLUCENCY_KEY "use-transparency"
#define APPEARANCE_ANIMATIONS_SCHEMA "org.pantheon.desktop.gala.animations"
#define APPEARANCE_ANIMATIONS_KEY "enable-animations"
static gint appearance_get_text_scale (Appearance* self,
                                GSettings* interface_settings);
static void appearance_set_text_scale (Appearance* self,
                                GSettings* interface_settings,
                                gint option);
static void appearance_update_text_size_modebutton (Appearance* self,
                                             GSettings* interface_settings);
Appearance* appearance_new (void);
Appearance* appearance_construct (GType object_type);
static GObject * appearance_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void _appearance___lambda17_ (Block5Data* _data5_);
static void __appearance___lambda17__g_settings_changed (GSettings* _sender,
                                                  const gchar* key,
                                                  gpointer self);
static void _appearance___lambda18_ (Block5Data* _data5_);
static void __appearance___lambda18__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                                        GtkWidget* widget,
                                                                        gpointer self);
static void appearance_finalize (GObject * obj);

static const gdouble APPEARANCE_TEXT_SCALE[4] = {0.75, (gdouble) 1, 1.25, 1.5};

static inline gpointer
appearance_get_instance_private (Appearance* self)
{
	return G_STRUCT_MEMBER_P (self, Appearance_private_offset);
}

static gint
appearance_get_text_scale (Appearance* self,
                           GSettings* interface_settings)
{
	gint result = 0;
	gdouble text_scaling_factor = 0.0;
	gdouble _tmp0_;
#line 88 "../src/Views/Appearance.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 88 "../src/Views/Appearance.vala"
	g_return_val_if_fail (interface_settings != NULL, 0);
#line 89 "../src/Views/Appearance.vala"
	text_scaling_factor = g_settings_get_double (interface_settings, APPEARANCE_TEXT_SIZE_KEY);
#line 91 "../src/Views/Appearance.vala"
	_tmp0_ = APPEARANCE_TEXT_SCALE[0];
#line 91 "../src/Views/Appearance.vala"
	if (text_scaling_factor <= _tmp0_) {
#line 92 "../src/Views/Appearance.vala"
		result = 0;
#line 92 "../src/Views/Appearance.vala"
		return result;
#line 136 "Appearance.c"
	} else {
		gdouble _tmp1_;
#line 93 "../src/Views/Appearance.vala"
		_tmp1_ = APPEARANCE_TEXT_SCALE[1];
#line 93 "../src/Views/Appearance.vala"
		if (text_scaling_factor <= _tmp1_) {
#line 94 "../src/Views/Appearance.vala"
			result = 1;
#line 94 "../src/Views/Appearance.vala"
			return result;
#line 147 "Appearance.c"
		} else {
			gdouble _tmp2_;
#line 95 "../src/Views/Appearance.vala"
			_tmp2_ = APPEARANCE_TEXT_SCALE[2];
#line 95 "../src/Views/Appearance.vala"
			if (text_scaling_factor <= _tmp2_) {
#line 96 "../src/Views/Appearance.vala"
				result = 2;
#line 96 "../src/Views/Appearance.vala"
				return result;
#line 158 "Appearance.c"
			} else {
#line 98 "../src/Views/Appearance.vala"
				result = 3;
#line 98 "../src/Views/Appearance.vala"
				return result;
#line 164 "Appearance.c"
			}
		}
	}
}

static void
appearance_set_text_scale (Appearance* self,
                           GSettings* interface_settings,
                           gint option)
{
	gdouble _tmp0_;
#line 102 "../src/Views/Appearance.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/Views/Appearance.vala"
	g_return_if_fail (interface_settings != NULL);
#line 103 "../src/Views/Appearance.vala"
	_tmp0_ = APPEARANCE_TEXT_SCALE[option];
#line 103 "../src/Views/Appearance.vala"
	g_settings_set_double (interface_settings, APPEARANCE_TEXT_SIZE_KEY, _tmp0_);
#line 184 "Appearance.c"
}

static void
appearance_update_text_size_modebutton (Appearance* self,
                                        GSettings* interface_settings)
{
	GraniteWidgetsModeButton* _tmp0_;
#line 106 "../src/Views/Appearance.vala"
	g_return_if_fail (self != NULL);
#line 106 "../src/Views/Appearance.vala"
	g_return_if_fail (interface_settings != NULL);
#line 107 "../src/Views/Appearance.vala"
	_tmp0_ = self->priv->text_size_modebutton;
#line 107 "../src/Views/Appearance.vala"
	granite_widgets_mode_button_set_active (_tmp0_, appearance_get_text_scale (self, interface_settings));
#line 200 "Appearance.c"
}

Appearance*
appearance_construct (GType object_type)
{
	Appearance * self = NULL;
#line 21 "../src/Views/Appearance.vala"
	self = (Appearance*) g_object_new (object_type, NULL);
#line 21 "../src/Views/Appearance.vala"
	return self;
#line 211 "Appearance.c"
}

Appearance*
appearance_new (void)
{
#line 21 "../src/Views/Appearance.vala"
	return appearance_construct (TYPE_APPEARANCE);
#line 219 "Appearance.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 35 "../src/Views/Appearance.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 35 "../src/Views/Appearance.vala"
	return _data5_;
#line 229 "Appearance.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 35 "../src/Views/Appearance.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 239 "Appearance.c"
		Appearance* self;
#line 35 "../src/Views/Appearance.vala"
		self = _data5_->self;
#line 35 "../src/Views/Appearance.vala"
		_g_object_unref0 (_data5_->interface_settings);
#line 35 "../src/Views/Appearance.vala"
		_g_object_unref0 (self);
#line 35 "../src/Views/Appearance.vala"
		g_slice_free (Block5Data, _data5_);
#line 249 "Appearance.c"
	}
}

static void
_appearance___lambda17_ (Block5Data* _data5_)
{
	Appearance* self;
	GSettings* _tmp0_;
#line 79 "../src/Views/Appearance.vala"
	self = _data5_->self;
#line 80 "../src/Views/Appearance.vala"
	_tmp0_ = _data5_->interface_settings;
#line 80 "../src/Views/Appearance.vala"
	appearance_update_text_size_modebutton (self, _tmp0_);
#line 264 "Appearance.c"
}

static void
__appearance___lambda17__g_settings_changed (GSettings* _sender,
                                             const gchar* key,
                                             gpointer self)
{
#line 79 "../src/Views/Appearance.vala"
	_appearance___lambda17_ (self);
#line 274 "Appearance.c"
}

static void
_appearance___lambda18_ (Block5Data* _data5_)
{
	Appearance* self;
	GSettings* _tmp0_;
	GraniteWidgetsModeButton* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 83 "../src/Views/Appearance.vala"
	self = _data5_->self;
#line 84 "../src/Views/Appearance.vala"
	_tmp0_ = _data5_->interface_settings;
#line 84 "../src/Views/Appearance.vala"
	_tmp1_ = self->priv->text_size_modebutton;
#line 84 "../src/Views/Appearance.vala"
	_tmp2_ = granite_widgets_mode_button_get_selected (_tmp1_);
#line 84 "../src/Views/Appearance.vala"
	_tmp3_ = _tmp2_;
#line 84 "../src/Views/Appearance.vala"
	appearance_set_text_scale (self, _tmp0_, _tmp3_);
#line 297 "Appearance.c"
}

static void
__appearance___lambda18__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                                   GtkWidget* widget,
                                                                   gpointer self)
{
#line 83 "../src/Views/Appearance.vala"
	_appearance___lambda18_ (self);
#line 307 "Appearance.c"
}

static GObject *
appearance_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Appearance * self;
	Block5Data* _data5_;
	GtkLabel* animations_label = NULL;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkSwitch* animations_switch = NULL;
	GtkSwitch* _tmp2_;
	GtkSwitch* _tmp3_;
	GtkLabel* translucency_label = NULL;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkSwitch* translucency_switch = NULL;
	GtkSwitch* _tmp6_;
	GtkSwitch* _tmp7_;
	GtkLabel* text_size_label = NULL;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GraniteWidgetsModeButton* _tmp10_;
	GraniteWidgetsModeButton* _tmp11_;
	GraniteWidgetsModeButton* _tmp12_;
	GraniteWidgetsModeButton* _tmp13_;
	GraniteWidgetsModeButton* _tmp14_;
	GtkLabel* _tmp15_;
	GtkSwitch* _tmp16_;
	GtkLabel* _tmp17_;
	GtkSwitch* _tmp18_;
	GtkLabel* _tmp19_;
	GraniteWidgetsModeButton* _tmp20_;
	GSettings* animations_settings = NULL;
	GSettings* _tmp21_;
	GSettings* _tmp22_;
	GtkSwitch* _tmp23_;
	GSettings* panel_settings = NULL;
	GSettings* _tmp24_;
	GSettings* _tmp25_;
	GtkSwitch* _tmp26_;
	GSettings* _tmp27_;
	GSettings* _tmp28_;
	GSettings* _tmp29_;
	GraniteWidgetsModeButton* _tmp30_;
#line 35 "../src/Views/Appearance.vala"
	parent_class = G_OBJECT_CLASS (appearance_parent_class);
#line 35 "../src/Views/Appearance.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 35 "../src/Views/Appearance.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APPEARANCE, Appearance);
#line 35 "../src/Views/Appearance.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 35 "../src/Views/Appearance.vala"
	_data5_->_ref_count_ = 1;
#line 35 "../src/Views/Appearance.vala"
	_data5_->self = g_object_ref (self);
#line 36 "../src/Views/Appearance.vala"
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
#line 37 "../src/Views/Appearance.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 38 "../src/Views/Appearance.vala"
	gtk_grid_set_row_spacing ((GtkGrid*) self, 6);
#line 39 "../src/Views/Appearance.vala"
	gtk_widget_set_margin_end ((GtkWidget*) self, 6);
#line 39 "../src/Views/Appearance.vala"
	gtk_widget_set_margin_start ((GtkWidget*) self, 6);
#line 41 "../src/Views/Appearance.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (_ ("Window animations:"));
#line 41 "../src/Views/Appearance.vala"
	g_object_ref_sink (_tmp0_);
#line 41 "../src/Views/Appearance.vala"
	animations_label = _tmp0_;
#line 42 "../src/Views/Appearance.vala"
	_tmp1_ = animations_label;
#line 42 "../src/Views/Appearance.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_END);
#line 44 "../src/Views/Appearance.vala"
	_tmp2_ = (GtkSwitch*) gtk_switch_new ();
#line 44 "../src/Views/Appearance.vala"
	g_object_ref_sink (_tmp2_);
#line 44 "../src/Views/Appearance.vala"
	animations_switch = _tmp2_;
#line 45 "../src/Views/Appearance.vala"
	_tmp3_ = animations_switch;
#line 45 "../src/Views/Appearance.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
#line 47 "../src/Views/Appearance.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new (_ ("Panel translucency:"));
#line 47 "../src/Views/Appearance.vala"
	g_object_ref_sink (_tmp4_);
#line 47 "../src/Views/Appearance.vala"
	translucency_label = _tmp4_;
#line 48 "../src/Views/Appearance.vala"
	_tmp5_ = translucency_label;
#line 48 "../src/Views/Appearance.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp5_, GTK_ALIGN_END);
#line 50 "../src/Views/Appearance.vala"
	_tmp6_ = (GtkSwitch*) gtk_switch_new ();
#line 50 "../src/Views/Appearance.vala"
	g_object_ref_sink (_tmp6_);
#line 50 "../src/Views/Appearance.vala"
	translucency_switch = _tmp6_;
#line 51 "../src/Views/Appearance.vala"
	_tmp7_ = translucency_switch;
#line 51 "../src/Views/Appearance.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_START);
#line 53 "../src/Views/Appearance.vala"
	_tmp8_ = (GtkLabel*) gtk_label_new (_ ("Text size:"));
#line 53 "../src/Views/Appearance.vala"
	g_object_ref_sink (_tmp8_);
#line 53 "../src/Views/Appearance.vala"
	text_size_label = _tmp8_;
#line 54 "../src/Views/Appearance.vala"
	_tmp9_ = text_size_label;
#line 54 "../src/Views/Appearance.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp9_, GTK_ALIGN_END);
#line 56 "../src/Views/Appearance.vala"
	_tmp10_ = granite_widgets_mode_button_new ();
#line 56 "../src/Views/Appearance.vala"
	g_object_ref_sink (_tmp10_);
#line 56 "../src/Views/Appearance.vala"
	_g_object_unref0 (self->priv->text_size_modebutton);
#line 56 "../src/Views/Appearance.vala"
	self->priv->text_size_modebutton = _tmp10_;
#line 57 "../src/Views/Appearance.vala"
	_tmp11_ = self->priv->text_size_modebutton;
#line 57 "../src/Views/Appearance.vala"
	granite_widgets_mode_button_append_text (_tmp11_, _ ("Small"));
#line 58 "../src/Views/Appearance.vala"
	_tmp12_ = self->priv->text_size_modebutton;
#line 58 "../src/Views/Appearance.vala"
	granite_widgets_mode_button_append_text (_tmp12_, _ ("Default"));
#line 59 "../src/Views/Appearance.vala"
	_tmp13_ = self->priv->text_size_modebutton;
#line 59 "../src/Views/Appearance.vala"
	granite_widgets_mode_button_append_text (_tmp13_, _ ("Large"));
#line 60 "../src/Views/Appearance.vala"
	_tmp14_ = self->priv->text_size_modebutton;
#line 60 "../src/Views/Appearance.vala"
	granite_widgets_mode_button_append_text (_tmp14_, _ ("Larger"));
#line 62 "../src/Views/Appearance.vala"
	_tmp15_ = animations_label;
#line 62 "../src/Views/Appearance.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp15_, 0, 0, 1, 1);
#line 63 "../src/Views/Appearance.vala"
	_tmp16_ = animations_switch;
#line 63 "../src/Views/Appearance.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp16_, 1, 0, 1, 1);
#line 64 "../src/Views/Appearance.vala"
	_tmp17_ = translucency_label;
#line 64 "../src/Views/Appearance.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp17_, 0, 1, 1, 1);
#line 65 "../src/Views/Appearance.vala"
	_tmp18_ = translucency_switch;
#line 65 "../src/Views/Appearance.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp18_, 1, 1, 1, 1);
#line 66 "../src/Views/Appearance.vala"
	_tmp19_ = text_size_label;
#line 66 "../src/Views/Appearance.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp19_, 0, 2, 1, 1);
#line 67 "../src/Views/Appearance.vala"
	_tmp20_ = self->priv->text_size_modebutton;
#line 67 "../src/Views/Appearance.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp20_, 1, 2, 1, 1);
#line 69 "../src/Views/Appearance.vala"
	_tmp21_ = g_settings_new (APPEARANCE_ANIMATIONS_SCHEMA);
#line 69 "../src/Views/Appearance.vala"
	animations_settings = _tmp21_;
#line 70 "../src/Views/Appearance.vala"
	_tmp22_ = animations_settings;
#line 70 "../src/Views/Appearance.vala"
	_tmp23_ = animations_switch;
#line 70 "../src/Views/Appearance.vala"
	g_settings_bind (_tmp22_, APPEARANCE_ANIMATIONS_KEY, (GObject*) _tmp23_, "active", G_SETTINGS_BIND_DEFAULT);
#line 72 "../src/Views/Appearance.vala"
	_tmp24_ = g_settings_new (APPEARANCE_PANEL_SCHEMA);
#line 72 "../src/Views/Appearance.vala"
	panel_settings = _tmp24_;
#line 73 "../src/Views/Appearance.vala"
	_tmp25_ = panel_settings;
#line 73 "../src/Views/Appearance.vala"
	_tmp26_ = translucency_switch;
#line 73 "../src/Views/Appearance.vala"
	g_settings_bind (_tmp25_, APPEARANCE_TRANSLUCENCY_KEY, (GObject*) _tmp26_, "active", G_SETTINGS_BIND_DEFAULT);
#line 75 "../src/Views/Appearance.vala"
	_tmp27_ = g_settings_new (APPEARANCE_INTERFACE_SCHEMA);
#line 75 "../src/Views/Appearance.vala"
	_data5_->interface_settings = _tmp27_;
#line 77 "../src/Views/Appearance.vala"
	_tmp28_ = _data5_->interface_settings;
#line 77 "../src/Views/Appearance.vala"
	appearance_update_text_size_modebutton (self, _tmp28_);
#line 79 "../src/Views/Appearance.vala"
	_tmp29_ = _data5_->interface_settings;
#line 79 "../src/Views/Appearance.vala"
	g_signal_connect_data (_tmp29_, "changed", (GCallback) __appearance___lambda17__g_settings_changed, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
#line 83 "../src/Views/Appearance.vala"
	_tmp30_ = self->priv->text_size_modebutton;
#line 83 "../src/Views/Appearance.vala"
	g_signal_connect_data (_tmp30_, "mode-changed", (GCallback) __appearance___lambda18__granite_widgets_mode_button_mode_changed, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
#line 35 "../src/Views/Appearance.vala"
	_g_object_unref0 (panel_settings);
#line 35 "../src/Views/Appearance.vala"
	_g_object_unref0 (animations_settings);
#line 35 "../src/Views/Appearance.vala"
	_g_object_unref0 (text_size_label);
#line 35 "../src/Views/Appearance.vala"
	_g_object_unref0 (translucency_switch);
#line 35 "../src/Views/Appearance.vala"
	_g_object_unref0 (translucency_label);
#line 35 "../src/Views/Appearance.vala"
	_g_object_unref0 (animations_switch);
#line 35 "../src/Views/Appearance.vala"
	_g_object_unref0 (animations_label);
#line 35 "../src/Views/Appearance.vala"
	block5_data_unref (_data5_);
#line 35 "../src/Views/Appearance.vala"
	_data5_ = NULL;
#line 35 "../src/Views/Appearance.vala"
	return obj;
#line 533 "Appearance.c"
}

static void
appearance_class_init (AppearanceClass * klass,
                       gpointer klass_data)
{
#line 21 "../src/Views/Appearance.vala"
	appearance_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Views/Appearance.vala"
	g_type_class_adjust_private_offset (klass, &Appearance_private_offset);
#line 21 "../src/Views/Appearance.vala"
	G_OBJECT_CLASS (klass)->constructor = appearance_constructor;
#line 21 "../src/Views/Appearance.vala"
	G_OBJECT_CLASS (klass)->finalize = appearance_finalize;
#line 548 "Appearance.c"
}

static void
appearance_instance_init (Appearance * self,
                          gpointer klass)
{
#line 21 "../src/Views/Appearance.vala"
	self->priv = appearance_get_instance_private (self);
#line 557 "Appearance.c"
}

static void
appearance_finalize (GObject * obj)
{
	Appearance * self;
#line 21 "../src/Views/Appearance.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APPEARANCE, Appearance);
#line 33 "../src/Views/Appearance.vala"
	_g_object_unref0 (self->priv->text_size_modebutton);
#line 21 "../src/Views/Appearance.vala"
	G_OBJECT_CLASS (appearance_parent_class)->finalize (obj);
#line 570 "Appearance.c"
}

GType
appearance_get_type (void)
{
	static volatile gsize appearance_type_id__volatile = 0;
	if (g_once_init_enter (&appearance_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AppearanceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) appearance_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Appearance), 0, (GInstanceInitFunc) appearance_instance_init, NULL };
		GType appearance_type_id;
		appearance_type_id = g_type_register_static (gtk_grid_get_type (), "Appearance", &g_define_type_info, 0);
		Appearance_private_offset = g_type_add_instance_private (appearance_type_id, sizeof (AppearancePrivate));
		g_once_init_leave (&appearance_type_id__volatile, appearance_type_id);
	}
	return appearance_type_id__volatile;
}

