/* WallpaperContainer.c generated by valac 0.44.3, the Vala compiler
 * generated from WallpaperContainer.vala, do not modify */

/*-
 * Copyright (c) 2015-2017 elementary LLC. (https://bugs.launchpad.net/switchboard-plug-pantheon-shell)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Erasmo Marín
 *
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>
#include <gexiv2/gexiv2.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#define TYPE_WALLPAPER_CONTAINER (wallpaper_container_get_type ())
#define WALLPAPER_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WALLPAPER_CONTAINER, WallpaperContainer))
#define WALLPAPER_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WALLPAPER_CONTAINER, WallpaperContainerClass))
#define IS_WALLPAPER_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WALLPAPER_CONTAINER))
#define IS_WALLPAPER_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WALLPAPER_CONTAINER))
#define WALLPAPER_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WALLPAPER_CONTAINER, WallpaperContainerClass))

typedef struct _WallpaperContainer WallpaperContainer;
typedef struct _WallpaperContainerClass WallpaperContainerClass;
typedef struct _WallpaperContainerPrivate WallpaperContainerPrivate;
enum  {
	WALLPAPER_CONTAINER_0_PROPERTY,
	WALLPAPER_CONTAINER_THUMB_PATH_PROPERTY,
	WALLPAPER_CONTAINER_THUMB_VALID_PROPERTY,
	WALLPAPER_CONTAINER_URI_PROPERTY,
	WALLPAPER_CONTAINER_THUMB_PROPERTY,
	WALLPAPER_CONTAINER_CHECKED_PROPERTY,
	WALLPAPER_CONTAINER_SELECTED_PROPERTY,
	WALLPAPER_CONTAINER_NUM_PROPERTIES
};
static GParamSpec* wallpaper_container_properties[WALLPAPER_CONTAINER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_THUMBNAIL_GENERATOR (thumbnail_generator_get_type ())
#define THUMBNAIL_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_GENERATOR, ThumbnailGenerator))
#define THUMBNAIL_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_GENERATOR, ThumbnailGeneratorClass))
#define IS_THUMBNAIL_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_GENERATOR))
#define IS_THUMBNAIL_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_GENERATOR))
#define THUMBNAIL_GENERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_GENERATOR, ThumbnailGeneratorClass))

typedef struct _ThumbnailGenerator ThumbnailGenerator;
typedef struct _ThumbnailGeneratorClass ThumbnailGeneratorClass;
typedef void (*ThumbnailGeneratorThumbnailReady) (gpointer user_data);
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _thumbnail_generator_unref0(var) ((var == NULL) ? NULL : (var = (thumbnail_generator_unref (var), NULL)))
typedef struct _WallpaperContainerUpdateThumbData WallpaperContainerUpdateThumbData;
typedef struct _Block1Data Block1Data;
enum  {
	WALLPAPER_CONTAINER_TRASH_SIGNAL,
	WALLPAPER_CONTAINER_NUM_SIGNALS
};
static guint wallpaper_container_signals[WALLPAPER_CONTAINER_NUM_SIGNALS] = {0};

struct _WallpaperContainer {
	GtkFlowBoxChild parent_instance;
	WallpaperContainerPrivate * priv;
};

struct _WallpaperContainerClass {
	GtkFlowBoxChildClass parent_class;
};

struct _WallpaperContainerPrivate {
	GtkGrid* card_box;
	GtkMenu* context_menu;
	GtkRevealer* check_revealer;
	GraniteAsyncImage* image;
	gchar* _thumb_path;
	gboolean _thumb_valid;
	gchar* _uri;
	GdkPixbuf* _thumb;
	gint scale;
};

struct _WallpaperContainerUpdateThumbData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	WallpaperContainer* self;
	const gchar* _tmp0_;
	GraniteAsyncImage* _tmp1_;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GError* e;
	GError* _tmp5_;
	const gchar* _tmp6_;
	GError* _inner_error0_;
};

struct _Block1Data {
	int _ref_count_;
	WallpaperContainer* self;
	GtkMenuItem* move_to_trash;
	GFile* file;
};

static gint WallpaperContainer_private_offset;
static gpointer wallpaper_container_parent_class = NULL;

GType wallpaper_container_get_type (void) G_GNUC_CONST;
#define WALLPAPER_CONTAINER_THUMB_WIDTH 162
#define WALLPAPER_CONTAINER_THUMB_HEIGHT 100
WallpaperContainer* wallpaper_container_new (const gchar* uri,
                                             const gchar* thumb_path,
                                             gboolean thumb_valid);
WallpaperContainer* wallpaper_container_construct (GType object_type,
                                                   const gchar* uri,
                                                   const gchar* thumb_path,
                                                   gboolean thumb_valid);
static void wallpaper_container_generate_and_load_thumb (WallpaperContainer* self);
gpointer thumbnail_generator_ref (gpointer instance);
void thumbnail_generator_unref (gpointer instance);
GParamSpec* param_spec_thumbnail_generator (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_thumbnail_generator (GValue* value,
                                    gpointer v_object);
void value_take_thumbnail_generator (GValue* value,
                                     gpointer v_object);
gpointer value_get_thumbnail_generator (const GValue* value);
GType thumbnail_generator_get_type (void) G_GNUC_CONST;
ThumbnailGenerator* thumbnail_generator_get_default (void);
void thumbnail_generator_get_thumbnail (ThumbnailGenerator* self,
                                        const gchar* uri,
                                        guint size,
                                        ThumbnailGeneratorThumbnailReady callback,
                                        gpointer callback_target);
const gchar* wallpaper_container_get_uri (WallpaperContainer* self);
static void __lambda6_ (WallpaperContainer* self);
void wallpaper_container_set_thumb_path (WallpaperContainer* self,
                                         const gchar* value);
static void wallpaper_container_update_thumb (WallpaperContainer* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
static void wallpaper_container_update_thumb_finish (WallpaperContainer* self,
                                              GAsyncResult* _res_);
static void ___lambda6__thumbnail_generator_thumbnail_ready (gpointer self);
static void wallpaper_container_load_artist_tooltip (WallpaperContainer* self);
static gboolean wallpaper_container_show_context_menu (WallpaperContainer* self,
                                                GtkWidget* sender,
                                                GdkEventButton* evt);
static void wallpaper_container_update_thumb_data_free (gpointer _data);
static void wallpaper_container_update_thumb_async_ready_wrapper (GObject *source_object,
                                                           GAsyncResult *res,
                                                           void *user_data);
static gboolean wallpaper_container_update_thumb_co (WallpaperContainerUpdateThumbData* _data_);
const gchar* wallpaper_container_get_thumb_path (WallpaperContainer* self);
static void wallpaper_container_update_thumb_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
gboolean wallpaper_container_get_thumb_valid (WallpaperContainer* self);
static void wallpaper_container_set_thumb_valid (WallpaperContainer* self,
                                          gboolean value);
static void wallpaper_container_set_uri (WallpaperContainer* self,
                                  const gchar* value);
GdkPixbuf* wallpaper_container_get_thumb (WallpaperContainer* self);
void wallpaper_container_set_thumb (WallpaperContainer* self,
                                    GdkPixbuf* value);
gboolean wallpaper_container_get_checked (WallpaperContainer* self);
void wallpaper_container_set_checked (WallpaperContainer* self,
                                      gboolean value);
gboolean wallpaper_container_get_selected (WallpaperContainer* self);
void wallpaper_container_set_selected (WallpaperContainer* self,
                                       gboolean value);
static GObject * wallpaper_container_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void _wallpaper_container____lambda7_ (WallpaperContainer* self);
static void __wallpaper_container____lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                               gpointer self);
static void _wallpaper_container____lambda8_ (Block1Data* _data1_,
                                       GObject* obj,
                                       GAsyncResult* res);
static void __wallpaper_container____lambda8__gasync_ready_callback (GObject* source_object,
                                                              GAsyncResult* res,
                                                              gpointer self);
static void _wallpaper_container___lambda9_ (WallpaperContainer* self);
static void __wallpaper_container___lambda9__gtk_flow_box_child_activate (GtkFlowBoxChild* _sender,
                                                                   gpointer self);
static gboolean _wallpaper_container_show_context_menu_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                               GdkEventButton* event,
                                                                               gpointer self);
static void wallpaper_container_finalize (GObject * obj);
static void _vala_wallpaper_container_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_wallpaper_container_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
wallpaper_container_get_instance_private (WallpaperContainer* self)
{
	return G_STRUCT_MEMBER_P (self, WallpaperContainer_private_offset);
}

WallpaperContainer*
wallpaper_container_construct (GType object_type,
                               const gchar* uri,
                               const gchar* thumb_path,
                               gboolean thumb_valid)
{
	WallpaperContainer * self = NULL;
#line 69 "../src/Widgets/WallpaperContainer.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 70 "../src/Widgets/WallpaperContainer.vala"
	self = (WallpaperContainer*) g_object_new (object_type, "uri", uri, "thumb-path", thumb_path, "thumb-valid", thumb_valid, NULL);
#line 69 "../src/Widgets/WallpaperContainer.vala"
	return self;
#line 247 "WallpaperContainer.c"
}

WallpaperContainer*
wallpaper_container_new (const gchar* uri,
                         const gchar* thumb_path,
                         gboolean thumb_valid)
{
#line 69 "../src/Widgets/WallpaperContainer.vala"
	return wallpaper_container_construct (TYPE_WALLPAPER_CONTAINER, uri, thumb_path, thumb_valid);
#line 257 "WallpaperContainer.c"
}

static void
__lambda6_ (WallpaperContainer* self)
{
	GError* _inner_error0_ = NULL;
	{
		GFile* file = NULL;
		const gchar* _tmp0_;
		GFile* _tmp1_;
		GFileInfo* info = NULL;
		GFileInfo* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 162 "../src/Widgets/WallpaperContainer.vala"
		_tmp0_ = self->priv->_uri;
#line 162 "../src/Widgets/WallpaperContainer.vala"
		_tmp1_ = g_file_new_for_uri (_tmp0_);
#line 162 "../src/Widgets/WallpaperContainer.vala"
		file = _tmp1_;
#line 163 "../src/Widgets/WallpaperContainer.vala"
		_tmp2_ = g_file_query_info (file, G_FILE_ATTRIBUTE_THUMBNAIL_PATH "," G_FILE_ATTRIBUTE_THUMBNAIL_IS_VALID, 0, NULL, &_inner_error0_);
#line 163 "../src/Widgets/WallpaperContainer.vala"
		info = _tmp2_;
#line 163 "../src/Widgets/WallpaperContainer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 163 "../src/Widgets/WallpaperContainer.vala"
			_g_object_unref0 (file);
#line 286 "WallpaperContainer.c"
			goto __catch4_g_error;
		}
#line 164 "../src/Widgets/WallpaperContainer.vala"
		_tmp3_ = g_file_info_get_attribute_as_string (info, G_FILE_ATTRIBUTE_THUMBNAIL_PATH);
#line 164 "../src/Widgets/WallpaperContainer.vala"
		_tmp4_ = _tmp3_;
#line 164 "../src/Widgets/WallpaperContainer.vala"
		wallpaper_container_set_thumb_path (self, _tmp4_);
#line 164 "../src/Widgets/WallpaperContainer.vala"
		_g_free0 (_tmp4_);
#line 165 "../src/Widgets/WallpaperContainer.vala"
		wallpaper_container_update_thumb (self, NULL, NULL);
#line 161 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (info);
#line 161 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (file);
#line 303 "WallpaperContainer.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 161 "../src/Widgets/WallpaperContainer.vala"
		e = _inner_error0_;
#line 161 "../src/Widgets/WallpaperContainer.vala"
		_inner_error0_ = NULL;
#line 167 "../src/Widgets/WallpaperContainer.vala"
		_tmp5_ = self->priv->_uri;
#line 167 "../src/Widgets/WallpaperContainer.vala"
		_tmp6_ = e;
#line 167 "../src/Widgets/WallpaperContainer.vala"
		_tmp7_ = _tmp6_->message;
#line 167 "../src/Widgets/WallpaperContainer.vala"
		g_warning ("WallpaperContainer.vala:167: Error loading thumbnail for '%s': %s", _tmp5_, _tmp7_);
#line 161 "../src/Widgets/WallpaperContainer.vala"
		_g_error_free0 (e);
#line 326 "WallpaperContainer.c"
	}
	__finally4:
#line 161 "../src/Widgets/WallpaperContainer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 161 "../src/Widgets/WallpaperContainer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 161 "../src/Widgets/WallpaperContainer.vala"
		g_clear_error (&_inner_error0_);
#line 161 "../src/Widgets/WallpaperContainer.vala"
		return;
#line 337 "WallpaperContainer.c"
	}
}

static void
___lambda6__thumbnail_generator_thumbnail_ready (gpointer self)
{
#line 160 "../src/Widgets/WallpaperContainer.vala"
	__lambda6_ ((WallpaperContainer*) self);
#line 346 "WallpaperContainer.c"
}

static void
wallpaper_container_generate_and_load_thumb (WallpaperContainer* self)
{
	ThumbnailGenerator* _tmp0_;
	ThumbnailGenerator* _tmp1_;
	const gchar* _tmp2_;
#line 159 "../src/Widgets/WallpaperContainer.vala"
	g_return_if_fail (self != NULL);
#line 160 "../src/Widgets/WallpaperContainer.vala"
	_tmp0_ = thumbnail_generator_get_default ();
#line 160 "../src/Widgets/WallpaperContainer.vala"
	_tmp1_ = _tmp0_;
#line 160 "../src/Widgets/WallpaperContainer.vala"
	_tmp2_ = self->priv->_uri;
#line 160 "../src/Widgets/WallpaperContainer.vala"
	thumbnail_generator_get_thumbnail (_tmp1_, _tmp2_, (guint) (WALLPAPER_CONTAINER_THUMB_WIDTH * self->priv->scale), ___lambda6__thumbnail_generator_thumbnail_ready, self);
#line 160 "../src/Widgets/WallpaperContainer.vala"
	_thumbnail_generator_unref0 (_tmp1_);
#line 367 "WallpaperContainer.c"
}

static void
wallpaper_container_load_artist_tooltip (WallpaperContainer* self)
{
	const gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 172 "../src/Widgets/WallpaperContainer.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/Widgets/WallpaperContainer.vala"
	_tmp0_ = self->priv->_uri;
#line 173 "../src/Widgets/WallpaperContainer.vala"
	if (_tmp0_ != NULL) {
#line 381 "WallpaperContainer.c"
		gchar* path = NULL;
		gchar* _tmp1_;
		GExiv2Metadata* metadata = NULL;
		GExiv2Metadata* _tmp12_;
#line 174 "../src/Widgets/WallpaperContainer.vala"
		_tmp1_ = g_strdup ("");
#line 174 "../src/Widgets/WallpaperContainer.vala"
		path = _tmp1_;
#line 390 "WallpaperContainer.c"
		{
			gchar* _tmp2_ = NULL;
			const gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			GExiv2Metadata* _tmp6_;
			GExiv2Metadata* _tmp7_;
			const gchar* _tmp8_;
#line 177 "../src/Widgets/WallpaperContainer.vala"
			_tmp3_ = self->priv->_uri;
#line 177 "../src/Widgets/WallpaperContainer.vala"
			_tmp4_ = g_filename_from_uri (_tmp3_, NULL, &_inner_error0_);
#line 177 "../src/Widgets/WallpaperContainer.vala"
			_tmp2_ = _tmp4_;
#line 177 "../src/Widgets/WallpaperContainer.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 407 "WallpaperContainer.c"
				goto __catch5_g_error;
			}
#line 177 "../src/Widgets/WallpaperContainer.vala"
			_tmp5_ = _tmp2_;
#line 177 "../src/Widgets/WallpaperContainer.vala"
			_tmp2_ = NULL;
#line 177 "../src/Widgets/WallpaperContainer.vala"
			_g_free0 (path);
#line 177 "../src/Widgets/WallpaperContainer.vala"
			path = _tmp5_;
#line 178 "../src/Widgets/WallpaperContainer.vala"
			_tmp6_ = gexiv2_metadata_new ();
#line 178 "../src/Widgets/WallpaperContainer.vala"
			_g_object_unref0 (metadata);
#line 178 "../src/Widgets/WallpaperContainer.vala"
			metadata = _tmp6_;
#line 179 "../src/Widgets/WallpaperContainer.vala"
			_tmp7_ = metadata;
#line 179 "../src/Widgets/WallpaperContainer.vala"
			_tmp8_ = path;
#line 179 "../src/Widgets/WallpaperContainer.vala"
			gexiv2_metadata_open_path (_tmp7_, _tmp8_, &_inner_error0_);
#line 179 "../src/Widgets/WallpaperContainer.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 179 "../src/Widgets/WallpaperContainer.vala"
				_g_free0 (_tmp2_);
#line 434 "WallpaperContainer.c"
				goto __catch5_g_error;
			}
#line 176 "../src/Widgets/WallpaperContainer.vala"
			_g_free0 (_tmp2_);
#line 439 "WallpaperContainer.c"
		}
		goto __finally5;
		__catch5_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp9_;
			GError* _tmp10_;
			const gchar* _tmp11_;
#line 176 "../src/Widgets/WallpaperContainer.vala"
			e = _inner_error0_;
#line 176 "../src/Widgets/WallpaperContainer.vala"
			_inner_error0_ = NULL;
#line 181 "../src/Widgets/WallpaperContainer.vala"
			_tmp9_ = path;
#line 181 "../src/Widgets/WallpaperContainer.vala"
			_tmp10_ = e;
#line 181 "../src/Widgets/WallpaperContainer.vala"
			_tmp11_ = _tmp10_->message;
#line 181 "../src/Widgets/WallpaperContainer.vala"
			g_warning ("WallpaperContainer.vala:181: Error parsing exif metadata of \"%s\": %s", _tmp9_, _tmp11_);
#line 182 "../src/Widgets/WallpaperContainer.vala"
			_g_error_free0 (e);
#line 182 "../src/Widgets/WallpaperContainer.vala"
			_g_object_unref0 (metadata);
#line 182 "../src/Widgets/WallpaperContainer.vala"
			_g_free0 (path);
#line 182 "../src/Widgets/WallpaperContainer.vala"
			return;
#line 468 "WallpaperContainer.c"
		}
		__finally5:
#line 176 "../src/Widgets/WallpaperContainer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 176 "../src/Widgets/WallpaperContainer.vala"
			_g_object_unref0 (metadata);
#line 176 "../src/Widgets/WallpaperContainer.vala"
			_g_free0 (path);
#line 176 "../src/Widgets/WallpaperContainer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 176 "../src/Widgets/WallpaperContainer.vala"
			g_clear_error (&_inner_error0_);
#line 176 "../src/Widgets/WallpaperContainer.vala"
			return;
#line 483 "WallpaperContainer.c"
		}
#line 185 "../src/Widgets/WallpaperContainer.vala"
		_tmp12_ = metadata;
#line 185 "../src/Widgets/WallpaperContainer.vala"
		if (gexiv2_metadata_has_exif (_tmp12_)) {
#line 489 "WallpaperContainer.c"
			gchar* artist_name = NULL;
			GExiv2Metadata* _tmp13_;
			gchar* _tmp14_;
			const gchar* _tmp15_;
#line 186 "../src/Widgets/WallpaperContainer.vala"
			_tmp13_ = metadata;
#line 186 "../src/Widgets/WallpaperContainer.vala"
			_tmp14_ = gexiv2_metadata_get_tag_string (_tmp13_, "Exif.Image.Artist");
#line 186 "../src/Widgets/WallpaperContainer.vala"
			artist_name = _tmp14_;
#line 187 "../src/Widgets/WallpaperContainer.vala"
			_tmp15_ = artist_name;
#line 187 "../src/Widgets/WallpaperContainer.vala"
			if (_tmp15_ != NULL) {
#line 504 "WallpaperContainer.c"
				const gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
#line 188 "../src/Widgets/WallpaperContainer.vala"
				_tmp16_ = artist_name;
#line 188 "../src/Widgets/WallpaperContainer.vala"
				_tmp17_ = g_strdup_printf (_ ("Artist: %s"), _tmp16_);
#line 188 "../src/Widgets/WallpaperContainer.vala"
				_tmp18_ = _tmp17_;
#line 188 "../src/Widgets/WallpaperContainer.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp18_);
#line 188 "../src/Widgets/WallpaperContainer.vala"
				_g_free0 (_tmp18_);
#line 518 "WallpaperContainer.c"
			}
#line 185 "../src/Widgets/WallpaperContainer.vala"
			_g_free0 (artist_name);
#line 522 "WallpaperContainer.c"
		}
#line 173 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (metadata);
#line 173 "../src/Widgets/WallpaperContainer.vala"
		_g_free0 (path);
#line 528 "WallpaperContainer.c"
	}
}

static gboolean
wallpaper_container_show_context_menu (WallpaperContainer* self,
                                       GtkWidget* sender,
                                       GdkEventButton* evt)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GdkEventType _tmp1_;
#line 194 "../src/Widgets/WallpaperContainer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 194 "../src/Widgets/WallpaperContainer.vala"
	g_return_val_if_fail (sender != NULL, FALSE);
#line 194 "../src/Widgets/WallpaperContainer.vala"
	g_return_val_if_fail (evt != NULL, FALSE);
#line 195 "../src/Widgets/WallpaperContainer.vala"
	_tmp1_ = evt->type;
#line 195 "../src/Widgets/WallpaperContainer.vala"
	if (_tmp1_ == GDK_BUTTON_PRESS) {
#line 195 "../src/Widgets/WallpaperContainer.vala"
		_tmp0_ = evt->button == ((guint) 3);
#line 552 "WallpaperContainer.c"
	} else {
#line 195 "../src/Widgets/WallpaperContainer.vala"
		_tmp0_ = FALSE;
#line 556 "WallpaperContainer.c"
	}
#line 195 "../src/Widgets/WallpaperContainer.vala"
	if (_tmp0_) {
#line 560 "WallpaperContainer.c"
		GtkMenu* _tmp2_;
#line 196 "../src/Widgets/WallpaperContainer.vala"
		_tmp2_ = self->priv->context_menu;
#line 196 "../src/Widgets/WallpaperContainer.vala"
		gtk_menu_popup_at_pointer (_tmp2_, NULL);
#line 197 "../src/Widgets/WallpaperContainer.vala"
		result = GDK_EVENT_STOP;
#line 197 "../src/Widgets/WallpaperContainer.vala"
		return result;
#line 570 "WallpaperContainer.c"
	}
#line 199 "../src/Widgets/WallpaperContainer.vala"
	result = GDK_EVENT_PROPAGATE;
#line 199 "../src/Widgets/WallpaperContainer.vala"
	return result;
#line 576 "WallpaperContainer.c"
}

static void
wallpaper_container_update_thumb_data_free (gpointer _data)
{
	WallpaperContainerUpdateThumbData* _data_;
	_data_ = _data;
#line 21 "../src/Widgets/WallpaperContainer.vala"
	_g_object_unref0 (_data_->self);
#line 21 "../src/Widgets/WallpaperContainer.vala"
	g_slice_free (WallpaperContainerUpdateThumbData, _data_);
#line 588 "WallpaperContainer.c"
}

static void
wallpaper_container_update_thumb_async_ready_wrapper (GObject *source_object,
                                                      GAsyncResult *res,
                                                      void *user_data)
{
	WallpaperContainerUpdateThumbData* _task_data_;
#line 21 "../src/Widgets/WallpaperContainer.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 21 "../src/Widgets/WallpaperContainer.vala"
	if (_task_data_->_callback_ != NULL) {
#line 21 "../src/Widgets/WallpaperContainer.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 603 "WallpaperContainer.c"
	}
#line 21 "../src/Widgets/WallpaperContainer.vala"
	_task_data_->_task_complete_ = TRUE;
#line 607 "WallpaperContainer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 21 "../src/Widgets/WallpaperContainer.vala"
	return self ? g_object_ref (self) : NULL;
#line 615 "WallpaperContainer.c"
}

static void
wallpaper_container_update_thumb (WallpaperContainer* self,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	WallpaperContainerUpdateThumbData* _data_;
	WallpaperContainer* _tmp0_;
#line 21 "../src/Widgets/WallpaperContainer.vala"
	_data_ = g_slice_new0 (WallpaperContainerUpdateThumbData);
#line 21 "../src/Widgets/WallpaperContainer.vala"
	_data_->_callback_ = _callback_;
#line 21 "../src/Widgets/WallpaperContainer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, wallpaper_container_update_thumb_async_ready_wrapper, _user_data_);
#line 21 "../src/Widgets/WallpaperContainer.vala"
	if (_callback_ == NULL) {
#line 21 "../src/Widgets/WallpaperContainer.vala"
		_data_->_task_complete_ = TRUE;
#line 635 "WallpaperContainer.c"
	}
#line 21 "../src/Widgets/WallpaperContainer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, wallpaper_container_update_thumb_data_free);
#line 21 "../src/Widgets/WallpaperContainer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "../src/Widgets/WallpaperContainer.vala"
	_data_->self = _tmp0_;
#line 21 "../src/Widgets/WallpaperContainer.vala"
	wallpaper_container_update_thumb_co (_data_);
#line 645 "WallpaperContainer.c"
}

static void
wallpaper_container_update_thumb_finish (WallpaperContainer* self,
                                         GAsyncResult* _res_)
{
	WallpaperContainerUpdateThumbData* _data_;
#line 21 "../src/Widgets/WallpaperContainer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 655 "WallpaperContainer.c"
}

static void
wallpaper_container_update_thumb_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	WallpaperContainerUpdateThumbData* _data_;
#line 208 "../src/Widgets/WallpaperContainer.vala"
	_data_ = _user_data_;
#line 208 "../src/Widgets/WallpaperContainer.vala"
	_data_->_source_object_ = source_object;
#line 208 "../src/Widgets/WallpaperContainer.vala"
	_data_->_res_ = _res_;
#line 208 "../src/Widgets/WallpaperContainer.vala"
	_data_->_task_complete_ = TRUE;
#line 208 "../src/Widgets/WallpaperContainer.vala"
	wallpaper_container_update_thumb_co (_data_);
#line 674 "WallpaperContainer.c"
}

static gboolean
wallpaper_container_update_thumb_co (WallpaperContainerUpdateThumbData* _data_)
{
#line 202 "../src/Widgets/WallpaperContainer.vala"
	switch (_data_->_state_) {
#line 202 "../src/Widgets/WallpaperContainer.vala"
		case 0:
#line 684 "WallpaperContainer.c"
		goto _state_0;
#line 202 "../src/Widgets/WallpaperContainer.vala"
		case 1:
#line 688 "WallpaperContainer.c"
		goto _state_1;
		default:
#line 202 "../src/Widgets/WallpaperContainer.vala"
		g_assert_not_reached ();
#line 693 "WallpaperContainer.c"
	}
	_state_0:
#line 203 "../src/Widgets/WallpaperContainer.vala"
	_data_->_tmp0_ = _data_->self->priv->_thumb_path;
#line 203 "../src/Widgets/WallpaperContainer.vala"
	if (_data_->_tmp0_ == NULL) {
#line 204 "../src/Widgets/WallpaperContainer.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 204 "../src/Widgets/WallpaperContainer.vala"
		if (_data_->_state_ != 0) {
#line 204 "../src/Widgets/WallpaperContainer.vala"
			while (!_data_->_task_complete_) {
#line 204 "../src/Widgets/WallpaperContainer.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 708 "WallpaperContainer.c"
			}
		}
#line 204 "../src/Widgets/WallpaperContainer.vala"
		g_object_unref (_data_->_async_result);
#line 204 "../src/Widgets/WallpaperContainer.vala"
		return FALSE;
#line 715 "WallpaperContainer.c"
	}
	{
#line 208 "../src/Widgets/WallpaperContainer.vala"
		_data_->_tmp1_ = _data_->self->priv->image;
#line 208 "../src/Widgets/WallpaperContainer.vala"
		_data_->_tmp2_ = _data_->self->priv->_thumb_path;
#line 208 "../src/Widgets/WallpaperContainer.vala"
		_data_->_tmp3_ = g_file_new_for_path (_data_->_tmp2_);
#line 208 "../src/Widgets/WallpaperContainer.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 208 "../src/Widgets/WallpaperContainer.vala"
		_data_->_state_ = 1;
#line 208 "../src/Widgets/WallpaperContainer.vala"
		granite_async_image_set_from_file_async (_data_->_tmp1_, _data_->_tmp4_, WALLPAPER_CONTAINER_THUMB_WIDTH, WALLPAPER_CONTAINER_THUMB_HEIGHT, FALSE, NULL, wallpaper_container_update_thumb_ready, _data_);
#line 208 "../src/Widgets/WallpaperContainer.vala"
		return FALSE;
#line 732 "WallpaperContainer.c"
		_state_1:
#line 208 "../src/Widgets/WallpaperContainer.vala"
		granite_async_image_set_from_file_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 208 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (_data_->_tmp4_);
#line 208 "../src/Widgets/WallpaperContainer.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 740 "WallpaperContainer.c"
			goto __catch6_g_error;
		}
	}
	goto __finally6;
	__catch6_g_error:
	{
#line 207 "../src/Widgets/WallpaperContainer.vala"
		_data_->e = _data_->_inner_error0_;
#line 207 "../src/Widgets/WallpaperContainer.vala"
		_data_->_inner_error0_ = NULL;
#line 210 "../src/Widgets/WallpaperContainer.vala"
		_data_->_tmp5_ = _data_->e;
#line 210 "../src/Widgets/WallpaperContainer.vala"
		_data_->_tmp6_ = _data_->_tmp5_->message;
#line 210 "../src/Widgets/WallpaperContainer.vala"
		g_warning ("WallpaperContainer.vala:210: %s", _data_->_tmp6_);
#line 207 "../src/Widgets/WallpaperContainer.vala"
		_g_error_free0 (_data_->e);
#line 759 "WallpaperContainer.c"
	}
	__finally6:
#line 207 "../src/Widgets/WallpaperContainer.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 207 "../src/Widgets/WallpaperContainer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 207 "../src/Widgets/WallpaperContainer.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 207 "../src/Widgets/WallpaperContainer.vala"
		g_object_unref (_data_->_async_result);
#line 207 "../src/Widgets/WallpaperContainer.vala"
		return FALSE;
#line 772 "WallpaperContainer.c"
	}
#line 213 "../src/Widgets/WallpaperContainer.vala"
	wallpaper_container_load_artist_tooltip (_data_->self);
#line 202 "../src/Widgets/WallpaperContainer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 202 "../src/Widgets/WallpaperContainer.vala"
	if (_data_->_state_ != 0) {
#line 202 "../src/Widgets/WallpaperContainer.vala"
		while (!_data_->_task_complete_) {
#line 202 "../src/Widgets/WallpaperContainer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 784 "WallpaperContainer.c"
		}
	}
#line 202 "../src/Widgets/WallpaperContainer.vala"
	g_object_unref (_data_->_async_result);
#line 202 "../src/Widgets/WallpaperContainer.vala"
	return FALSE;
#line 791 "WallpaperContainer.c"
}

const gchar*
wallpaper_container_get_thumb_path (WallpaperContainer* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../src/Widgets/WallpaperContainer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/Widgets/WallpaperContainer.vala"
	_tmp0_ = self->priv->_thumb_path;
#line 32 "../src/Widgets/WallpaperContainer.vala"
	result = _tmp0_;
#line 32 "../src/Widgets/WallpaperContainer.vala"
	return result;
#line 807 "WallpaperContainer.c"
}

void
wallpaper_container_set_thumb_path (WallpaperContainer* self,
                                    const gchar* value)
{
#line 32 "../src/Widgets/WallpaperContainer.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Widgets/WallpaperContainer.vala"
	if (g_strcmp0 (value, wallpaper_container_get_thumb_path (self)) != 0) {
#line 818 "WallpaperContainer.c"
		gchar* _tmp0_;
#line 32 "../src/Widgets/WallpaperContainer.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../src/Widgets/WallpaperContainer.vala"
		_g_free0 (self->priv->_thumb_path);
#line 32 "../src/Widgets/WallpaperContainer.vala"
		self->priv->_thumb_path = _tmp0_;
#line 32 "../src/Widgets/WallpaperContainer.vala"
		g_object_notify_by_pspec ((GObject *) self, wallpaper_container_properties[WALLPAPER_CONTAINER_THUMB_PATH_PROPERTY]);
#line 828 "WallpaperContainer.c"
	}
}

gboolean
wallpaper_container_get_thumb_valid (WallpaperContainer* self)
{
	gboolean result;
#line 33 "../src/Widgets/WallpaperContainer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "../src/Widgets/WallpaperContainer.vala"
	result = self->priv->_thumb_valid;
#line 33 "../src/Widgets/WallpaperContainer.vala"
	return result;
#line 842 "WallpaperContainer.c"
}

static void
wallpaper_container_set_thumb_valid (WallpaperContainer* self,
                                     gboolean value)
{
#line 33 "../src/Widgets/WallpaperContainer.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Widgets/WallpaperContainer.vala"
	if (wallpaper_container_get_thumb_valid (self) != value) {
#line 33 "../src/Widgets/WallpaperContainer.vala"
		self->priv->_thumb_valid = value;
#line 33 "../src/Widgets/WallpaperContainer.vala"
		g_object_notify_by_pspec ((GObject *) self, wallpaper_container_properties[WALLPAPER_CONTAINER_THUMB_VALID_PROPERTY]);
#line 857 "WallpaperContainer.c"
	}
}

const gchar*
wallpaper_container_get_uri (WallpaperContainer* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 34 "../src/Widgets/WallpaperContainer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/Widgets/WallpaperContainer.vala"
	_tmp0_ = self->priv->_uri;
#line 34 "../src/Widgets/WallpaperContainer.vala"
	result = _tmp0_;
#line 34 "../src/Widgets/WallpaperContainer.vala"
	return result;
#line 874 "WallpaperContainer.c"
}

static void
wallpaper_container_set_uri (WallpaperContainer* self,
                             const gchar* value)
{
#line 34 "../src/Widgets/WallpaperContainer.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Widgets/WallpaperContainer.vala"
	if (g_strcmp0 (value, wallpaper_container_get_uri (self)) != 0) {
#line 885 "WallpaperContainer.c"
		gchar* _tmp0_;
#line 34 "../src/Widgets/WallpaperContainer.vala"
		_tmp0_ = g_strdup (value);
#line 34 "../src/Widgets/WallpaperContainer.vala"
		_g_free0 (self->priv->_uri);
#line 34 "../src/Widgets/WallpaperContainer.vala"
		self->priv->_uri = _tmp0_;
#line 34 "../src/Widgets/WallpaperContainer.vala"
		g_object_notify_by_pspec ((GObject *) self, wallpaper_container_properties[WALLPAPER_CONTAINER_URI_PROPERTY]);
#line 895 "WallpaperContainer.c"
	}
}

GdkPixbuf*
wallpaper_container_get_thumb (WallpaperContainer* self)
{
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_;
#line 35 "../src/Widgets/WallpaperContainer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Widgets/WallpaperContainer.vala"
	_tmp0_ = self->priv->_thumb;
#line 35 "../src/Widgets/WallpaperContainer.vala"
	result = _tmp0_;
#line 35 "../src/Widgets/WallpaperContainer.vala"
	return result;
#line 912 "WallpaperContainer.c"
}

void
wallpaper_container_set_thumb (WallpaperContainer* self,
                               GdkPixbuf* value)
{
#line 35 "../src/Widgets/WallpaperContainer.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Widgets/WallpaperContainer.vala"
	if (wallpaper_container_get_thumb (self) != value) {
#line 923 "WallpaperContainer.c"
		GdkPixbuf* _tmp0_;
#line 35 "../src/Widgets/WallpaperContainer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 35 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (self->priv->_thumb);
#line 35 "../src/Widgets/WallpaperContainer.vala"
		self->priv->_thumb = _tmp0_;
#line 35 "../src/Widgets/WallpaperContainer.vala"
		g_object_notify_by_pspec ((GObject *) self, wallpaper_container_properties[WALLPAPER_CONTAINER_THUMB_PROPERTY]);
#line 933 "WallpaperContainer.c"
	}
}

gboolean
wallpaper_container_get_checked (WallpaperContainer* self)
{
	gboolean result;
#line 40 "../src/Widgets/WallpaperContainer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../src/Widgets/WallpaperContainer.vala"
	result = (gtk_widget_get_state_flags ((GtkWidget*) self) & GTK_STATE_FLAG_CHECKED) == GTK_STATE_FLAG_CHECKED;
#line 41 "../src/Widgets/WallpaperContainer.vala"
	return result;
#line 947 "WallpaperContainer.c"
}

void
wallpaper_container_set_checked (WallpaperContainer* self,
                                 gboolean value)
{
#line 42 "../src/Widgets/WallpaperContainer.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/Widgets/WallpaperContainer.vala"
	if (value) {
#line 958 "WallpaperContainer.c"
		GtkGrid* _tmp0_;
		GtkRevealer* _tmp1_;
#line 44 "../src/Widgets/WallpaperContainer.vala"
		_tmp0_ = self->priv->card_box;
#line 44 "../src/Widgets/WallpaperContainer.vala"
		gtk_widget_set_state_flags ((GtkWidget*) _tmp0_, GTK_STATE_FLAG_CHECKED, FALSE);
#line 45 "../src/Widgets/WallpaperContainer.vala"
		_tmp1_ = self->priv->check_revealer;
#line 45 "../src/Widgets/WallpaperContainer.vala"
		gtk_revealer_set_reveal_child (_tmp1_, TRUE);
#line 969 "WallpaperContainer.c"
	} else {
		GtkGrid* _tmp2_;
		GtkRevealer* _tmp3_;
#line 47 "../src/Widgets/WallpaperContainer.vala"
		_tmp2_ = self->priv->card_box;
#line 47 "../src/Widgets/WallpaperContainer.vala"
		gtk_widget_unset_state_flags ((GtkWidget*) _tmp2_, GTK_STATE_FLAG_CHECKED);
#line 48 "../src/Widgets/WallpaperContainer.vala"
		_tmp3_ = self->priv->check_revealer;
#line 48 "../src/Widgets/WallpaperContainer.vala"
		gtk_revealer_set_reveal_child (_tmp3_, FALSE);
#line 981 "WallpaperContainer.c"
	}
#line 51 "../src/Widgets/WallpaperContainer.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 42 "../src/Widgets/WallpaperContainer.vala"
	g_object_notify_by_pspec ((GObject *) self, wallpaper_container_properties[WALLPAPER_CONTAINER_CHECKED_PROPERTY]);
#line 987 "WallpaperContainer.c"
}

gboolean
wallpaper_container_get_selected (WallpaperContainer* self)
{
	gboolean result;
#line 56 "../src/Widgets/WallpaperContainer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 57 "../src/Widgets/WallpaperContainer.vala"
	result = (gtk_widget_get_state_flags ((GtkWidget*) self) & GTK_STATE_FLAG_SELECTED) == GTK_STATE_FLAG_SELECTED;
#line 57 "../src/Widgets/WallpaperContainer.vala"
	return result;
#line 1000 "WallpaperContainer.c"
}

void
wallpaper_container_set_selected (WallpaperContainer* self,
                                  gboolean value)
{
#line 58 "../src/Widgets/WallpaperContainer.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/Widgets/WallpaperContainer.vala"
	if (value) {
#line 60 "../src/Widgets/WallpaperContainer.vala"
		gtk_widget_set_state_flags ((GtkWidget*) self, GTK_STATE_FLAG_SELECTED, FALSE);
#line 1013 "WallpaperContainer.c"
	} else {
#line 62 "../src/Widgets/WallpaperContainer.vala"
		gtk_widget_unset_state_flags ((GtkWidget*) self, GTK_STATE_FLAG_SELECTED);
#line 1017 "WallpaperContainer.c"
	}
#line 65 "../src/Widgets/WallpaperContainer.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 58 "../src/Widgets/WallpaperContainer.vala"
	g_object_notify_by_pspec ((GObject *) self, wallpaper_container_properties[WALLPAPER_CONTAINER_SELECTED_PROPERTY]);
#line 1023 "WallpaperContainer.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 117 "../src/Widgets/WallpaperContainer.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 117 "../src/Widgets/WallpaperContainer.vala"
	return _data1_;
#line 1033 "WallpaperContainer.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 117 "../src/Widgets/WallpaperContainer.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1043 "WallpaperContainer.c"
		WallpaperContainer* self;
#line 117 "../src/Widgets/WallpaperContainer.vala"
		self = _data1_->self;
#line 117 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (_data1_->file);
#line 117 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (_data1_->move_to_trash);
#line 117 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (self);
#line 117 "../src/Widgets/WallpaperContainer.vala"
		g_slice_free (Block1Data, _data1_);
#line 1055 "WallpaperContainer.c"
	}
}

static void
_wallpaper_container____lambda7_ (WallpaperContainer* self)
{
#line 119 "../src/Widgets/WallpaperContainer.vala"
	g_signal_emit (self, wallpaper_container_signals[WALLPAPER_CONTAINER_TRASH_SIGNAL], 0);
#line 1064 "WallpaperContainer.c"
}

static void
__wallpaper_container____lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                          gpointer self)
{
#line 119 "../src/Widgets/WallpaperContainer.vala"
	_wallpaper_container____lambda7_ ((WallpaperContainer*) self);
#line 1073 "WallpaperContainer.c"
}

static void
_wallpaper_container____lambda8_ (Block1Data* _data1_,
                                  GObject* obj,
                                  GAsyncResult* res)
{
	WallpaperContainer* self;
	GError* _inner_error0_ = NULL;
#line 122 "../src/Widgets/WallpaperContainer.vala"
	self = _data1_->self;
#line 122 "../src/Widgets/WallpaperContainer.vala"
	g_return_if_fail (res != NULL);
#line 1087 "WallpaperContainer.c"
	{
		GFileInfo* info = NULL;
		GFile* _tmp0_;
		GFileInfo* _tmp1_;
		GtkMenuItem* _tmp2_;
		GFileInfo* _tmp3_;
#line 124 "../src/Widgets/WallpaperContainer.vala"
		_tmp0_ = _data1_->file;
#line 124 "../src/Widgets/WallpaperContainer.vala"
		_tmp1_ = g_file_query_info_finish (_tmp0_, res, &_inner_error0_);
#line 124 "../src/Widgets/WallpaperContainer.vala"
		info = _tmp1_;
#line 124 "../src/Widgets/WallpaperContainer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1102 "WallpaperContainer.c"
			goto __catch7_g_error;
		}
#line 125 "../src/Widgets/WallpaperContainer.vala"
		_tmp2_ = _data1_->move_to_trash;
#line 125 "../src/Widgets/WallpaperContainer.vala"
		_tmp3_ = info;
#line 125 "../src/Widgets/WallpaperContainer.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, g_file_info_get_attribute_boolean (_tmp3_, G_FILE_ATTRIBUTE_ACCESS_CAN_DELETE));
#line 123 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (info);
#line 1113 "WallpaperContainer.c"
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 123 "../src/Widgets/WallpaperContainer.vala"
		e = _inner_error0_;
#line 123 "../src/Widgets/WallpaperContainer.vala"
		_inner_error0_ = NULL;
#line 127 "../src/Widgets/WallpaperContainer.vala"
		_tmp4_ = e;
#line 127 "../src/Widgets/WallpaperContainer.vala"
		_tmp5_ = _tmp4_->message;
#line 127 "../src/Widgets/WallpaperContainer.vala"
		g_critical ("WallpaperContainer.vala:127: %s", _tmp5_);
#line 123 "../src/Widgets/WallpaperContainer.vala"
		_g_error_free0 (e);
#line 1133 "WallpaperContainer.c"
	}
	__finally7:
#line 123 "../src/Widgets/WallpaperContainer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 123 "../src/Widgets/WallpaperContainer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 123 "../src/Widgets/WallpaperContainer.vala"
		g_clear_error (&_inner_error0_);
#line 123 "../src/Widgets/WallpaperContainer.vala"
		return;
#line 1144 "WallpaperContainer.c"
	}
}

static void
__wallpaper_container____lambda8__gasync_ready_callback (GObject* source_object,
                                                         GAsyncResult* res,
                                                         gpointer self)
{
#line 122 "../src/Widgets/WallpaperContainer.vala"
	_wallpaper_container____lambda8_ (self, source_object, res);
#line 122 "../src/Widgets/WallpaperContainer.vala"
	block1_data_unref (self);
#line 1157 "WallpaperContainer.c"
}

static void
_wallpaper_container___lambda9_ (WallpaperContainer* self)
{
#line 137 "../src/Widgets/WallpaperContainer.vala"
	wallpaper_container_set_checked (self, TRUE);
#line 1165 "WallpaperContainer.c"
}

static void
__wallpaper_container___lambda9__gtk_flow_box_child_activate (GtkFlowBoxChild* _sender,
                                                              gpointer self)
{
#line 136 "../src/Widgets/WallpaperContainer.vala"
	_wallpaper_container___lambda9_ ((WallpaperContainer*) self);
#line 1174 "WallpaperContainer.c"
}

static gboolean
_wallpaper_container_show_context_menu_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                      GdkEventButton* event,
                                                                      gpointer self)
{
	gboolean result;
	result = wallpaper_container_show_context_menu ((WallpaperContainer*) self, _sender, event);
#line 140 "../src/Widgets/WallpaperContainer.vala"
	return result;
#line 1186 "WallpaperContainer.c"
}

static GObject *
wallpaper_container_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WallpaperContainer * self;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp4_;
	GtkCssProvider* _tmp5_;
	GdkScreen* _tmp6_;
	GtkCssProvider* _tmp7_;
	GraniteAsyncImage* _tmp8_;
	GraniteAsyncImage* _tmp9_;
	GraniteAsyncImage* _tmp10_;
	GraniteAsyncImage* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkGrid* _tmp13_;
	GtkGrid* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkGrid* _tmp16_;
	GraniteAsyncImage* _tmp17_;
	GtkGrid* _tmp18_;
	GtkImage* check = NULL;
	GtkImage* _tmp19_;
	GtkImage* _tmp20_;
	GtkImage* _tmp21_;
	GtkRevealer* _tmp22_;
	GtkRevealer* _tmp23_;
	GtkRevealer* _tmp24_;
	GtkImage* _tmp25_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp26_;
	GtkOverlay* _tmp27_;
	GtkGrid* _tmp28_;
	GtkOverlay* _tmp29_;
	GtkRevealer* _tmp30_;
	GtkEventBox* event_box = NULL;
	GtkEventBox* _tmp31_;
	GtkEventBox* _tmp32_;
	GtkOverlay* _tmp33_;
	GtkEventBox* _tmp34_;
	const gchar* _tmp35_;
	GtkEventBox* _tmp45_;
	GError* _inner_error0_ = NULL;
#line 73 "../src/Widgets/WallpaperContainer.vala"
	parent_class = G_OBJECT_CLASS (wallpaper_container_parent_class);
#line 73 "../src/Widgets/WallpaperContainer.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 73 "../src/Widgets/WallpaperContainer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WALLPAPER_CONTAINER, WallpaperContainer);
#line 74 "../src/Widgets/WallpaperContainer.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 74 "../src/Widgets/WallpaperContainer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 74 "../src/Widgets/WallpaperContainer.vala"
	style_context = _tmp1_;
#line 75 "../src/Widgets/WallpaperContainer.vala"
	_tmp2_ = style_context;
#line 75 "../src/Widgets/WallpaperContainer.vala"
	gtk_style_context_add_class (_tmp2_, "wallpaper-container");
#line 77 "../src/Widgets/WallpaperContainer.vala"
	_tmp3_ = style_context;
#line 77 "../src/Widgets/WallpaperContainer.vala"
	self->priv->scale = gtk_style_context_get_scale (_tmp3_);
#line 79 "../src/Widgets/WallpaperContainer.vala"
	g_object_set ((GtkWidget*) self, "height-request", WALLPAPER_CONTAINER_THUMB_HEIGHT + 18, NULL);
#line 80 "../src/Widgets/WallpaperContainer.vala"
	g_object_set ((GtkWidget*) self, "width-request", WALLPAPER_CONTAINER_THUMB_WIDTH + 18, NULL);
#line 82 "../src/Widgets/WallpaperContainer.vala"
	_tmp4_ = gtk_css_provider_new ();
#line 82 "../src/Widgets/WallpaperContainer.vala"
	provider = _tmp4_;
#line 83 "../src/Widgets/WallpaperContainer.vala"
	_tmp5_ = provider;
#line 83 "../src/Widgets/WallpaperContainer.vala"
	gtk_css_provider_load_from_resource (_tmp5_, "/io/elementary/switchboard/plug/pantheon-shell/plug.css");
#line 84 "../src/Widgets/WallpaperContainer.vala"
	_tmp6_ = gdk_screen_get_default ();
#line 84 "../src/Widgets/WallpaperContainer.vala"
	_tmp7_ = provider;
#line 84 "../src/Widgets/WallpaperContainer.vala"
	gtk_style_context_add_provider_for_screen (_tmp6_, (GtkStyleProvider*) _tmp7_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 86 "../src/Widgets/WallpaperContainer.vala"
	_tmp8_ = granite_async_image_new (TRUE, TRUE);
#line 86 "../src/Widgets/WallpaperContainer.vala"
	g_object_ref_sink (_tmp8_);
#line 86 "../src/Widgets/WallpaperContainer.vala"
	_g_object_unref0 (self->priv->image);
#line 86 "../src/Widgets/WallpaperContainer.vala"
	self->priv->image = _tmp8_;
#line 87 "../src/Widgets/WallpaperContainer.vala"
	_tmp9_ = self->priv->image;
#line 87 "../src/Widgets/WallpaperContainer.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp9_, GTK_ALIGN_CENTER);
#line 88 "../src/Widgets/WallpaperContainer.vala"
	_tmp10_ = self->priv->image;
#line 88 "../src/Widgets/WallpaperContainer.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp10_, GTK_ALIGN_CENTER);
#line 89 "../src/Widgets/WallpaperContainer.vala"
	_tmp11_ = self->priv->image;
#line 89 "../src/Widgets/WallpaperContainer.vala"
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) _tmp11_);
#line 89 "../src/Widgets/WallpaperContainer.vala"
	gtk_style_context_set_scale (_tmp12_, 1);
#line 92 "../src/Widgets/WallpaperContainer.vala"
	_tmp13_ = (GtkGrid*) gtk_grid_new ();
#line 92 "../src/Widgets/WallpaperContainer.vala"
	g_object_ref_sink (_tmp13_);
#line 92 "../src/Widgets/WallpaperContainer.vala"
	_g_object_unref0 (self->priv->card_box);
#line 92 "../src/Widgets/WallpaperContainer.vala"
	self->priv->card_box = _tmp13_;
#line 93 "../src/Widgets/WallpaperContainer.vala"
	_tmp14_ = self->priv->card_box;
#line 93 "../src/Widgets/WallpaperContainer.vala"
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
#line 93 "../src/Widgets/WallpaperContainer.vala"
	gtk_style_context_add_class (_tmp15_, "card");
#line 94 "../src/Widgets/WallpaperContainer.vala"
	_tmp16_ = self->priv->card_box;
#line 94 "../src/Widgets/WallpaperContainer.vala"
	_tmp17_ = self->priv->image;
#line 94 "../src/Widgets/WallpaperContainer.vala"
	gtk_container_add ((GtkContainer*) _tmp16_, (GtkWidget*) _tmp17_);
#line 95 "../src/Widgets/WallpaperContainer.vala"
	_tmp18_ = self->priv->card_box;
#line 95 "../src/Widgets/WallpaperContainer.vala"
	g_object_set ((GtkWidget*) _tmp18_, "margin", 9, NULL);
#line 97 "../src/Widgets/WallpaperContainer.vala"
	_tmp19_ = (GtkImage*) gtk_image_new_from_icon_name ("selection-checked", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 97 "../src/Widgets/WallpaperContainer.vala"
	g_object_ref_sink (_tmp19_);
#line 97 "../src/Widgets/WallpaperContainer.vala"
	check = _tmp19_;
#line 98 "../src/Widgets/WallpaperContainer.vala"
	_tmp20_ = check;
#line 98 "../src/Widgets/WallpaperContainer.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp20_, GTK_ALIGN_START);
#line 99 "../src/Widgets/WallpaperContainer.vala"
	_tmp21_ = check;
#line 99 "../src/Widgets/WallpaperContainer.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp21_, GTK_ALIGN_START);
#line 101 "../src/Widgets/WallpaperContainer.vala"
	_tmp22_ = (GtkRevealer*) gtk_revealer_new ();
#line 101 "../src/Widgets/WallpaperContainer.vala"
	g_object_ref_sink (_tmp22_);
#line 101 "../src/Widgets/WallpaperContainer.vala"
	_g_object_unref0 (self->priv->check_revealer);
#line 101 "../src/Widgets/WallpaperContainer.vala"
	self->priv->check_revealer = _tmp22_;
#line 102 "../src/Widgets/WallpaperContainer.vala"
	_tmp23_ = self->priv->check_revealer;
#line 102 "../src/Widgets/WallpaperContainer.vala"
	gtk_revealer_set_transition_type (_tmp23_, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
#line 103 "../src/Widgets/WallpaperContainer.vala"
	_tmp24_ = self->priv->check_revealer;
#line 103 "../src/Widgets/WallpaperContainer.vala"
	_tmp25_ = check;
#line 103 "../src/Widgets/WallpaperContainer.vala"
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
#line 105 "../src/Widgets/WallpaperContainer.vala"
	_tmp26_ = (GtkOverlay*) gtk_overlay_new ();
#line 105 "../src/Widgets/WallpaperContainer.vala"
	g_object_ref_sink (_tmp26_);
#line 105 "../src/Widgets/WallpaperContainer.vala"
	overlay = _tmp26_;
#line 106 "../src/Widgets/WallpaperContainer.vala"
	_tmp27_ = overlay;
#line 106 "../src/Widgets/WallpaperContainer.vala"
	_tmp28_ = self->priv->card_box;
#line 106 "../src/Widgets/WallpaperContainer.vala"
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
#line 107 "../src/Widgets/WallpaperContainer.vala"
	_tmp29_ = overlay;
#line 107 "../src/Widgets/WallpaperContainer.vala"
	_tmp30_ = self->priv->check_revealer;
#line 107 "../src/Widgets/WallpaperContainer.vala"
	gtk_overlay_add_overlay (_tmp29_, (GtkWidget*) _tmp30_);
#line 109 "../src/Widgets/WallpaperContainer.vala"
	_tmp31_ = (GtkEventBox*) gtk_event_box_new ();
#line 109 "../src/Widgets/WallpaperContainer.vala"
	g_object_ref_sink (_tmp31_);
#line 109 "../src/Widgets/WallpaperContainer.vala"
	event_box = _tmp31_;
#line 110 "../src/Widgets/WallpaperContainer.vala"
	_tmp32_ = event_box;
#line 110 "../src/Widgets/WallpaperContainer.vala"
	_tmp33_ = overlay;
#line 110 "../src/Widgets/WallpaperContainer.vala"
	gtk_container_add ((GtkContainer*) _tmp32_, (GtkWidget*) _tmp33_);
#line 112 "../src/Widgets/WallpaperContainer.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 113 "../src/Widgets/WallpaperContainer.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 114 "../src/Widgets/WallpaperContainer.vala"
	g_object_set ((GtkWidget*) self, "margin", 6, NULL);
#line 115 "../src/Widgets/WallpaperContainer.vala"
	_tmp34_ = event_box;
#line 115 "../src/Widgets/WallpaperContainer.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp34_);
#line 117 "../src/Widgets/WallpaperContainer.vala"
	_tmp35_ = self->priv->_uri;
#line 117 "../src/Widgets/WallpaperContainer.vala"
	if (_tmp35_ != NULL) {
#line 1400 "WallpaperContainer.c"
		Block1Data* _data1_;
		GtkMenuItem* _tmp36_;
		GtkMenuItem* _tmp37_;
		const gchar* _tmp38_;
		GFile* _tmp39_;
		GFile* _tmp40_;
		GtkMenu* _tmp41_;
		GtkMenu* _tmp42_;
		GtkMenuItem* _tmp43_;
		GtkMenu* _tmp44_;
#line 117 "../src/Widgets/WallpaperContainer.vala"
		_data1_ = g_slice_new0 (Block1Data);
#line 117 "../src/Widgets/WallpaperContainer.vala"
		_data1_->_ref_count_ = 1;
#line 117 "../src/Widgets/WallpaperContainer.vala"
		_data1_->self = g_object_ref (self);
#line 118 "../src/Widgets/WallpaperContainer.vala"
		_tmp36_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Remove"));
#line 118 "../src/Widgets/WallpaperContainer.vala"
		g_object_ref_sink (_tmp36_);
#line 118 "../src/Widgets/WallpaperContainer.vala"
		_data1_->move_to_trash = _tmp36_;
#line 119 "../src/Widgets/WallpaperContainer.vala"
		_tmp37_ = _data1_->move_to_trash;
#line 119 "../src/Widgets/WallpaperContainer.vala"
		g_signal_connect_object (_tmp37_, "activate", (GCallback) __wallpaper_container____lambda7__gtk_menu_item_activate, self, 0);
#line 121 "../src/Widgets/WallpaperContainer.vala"
		_tmp38_ = self->priv->_uri;
#line 121 "../src/Widgets/WallpaperContainer.vala"
		_tmp39_ = g_file_new_for_uri (_tmp38_);
#line 121 "../src/Widgets/WallpaperContainer.vala"
		_data1_->file = _tmp39_;
#line 122 "../src/Widgets/WallpaperContainer.vala"
		_tmp40_ = _data1_->file;
#line 122 "../src/Widgets/WallpaperContainer.vala"
		g_file_query_info_async (_tmp40_, G_FILE_ATTRIBUTE_ACCESS_CAN_DELETE, 0, G_PRIORITY_DEFAULT, NULL, __wallpaper_container____lambda8__gasync_ready_callback, block1_data_ref (_data1_));
#line 131 "../src/Widgets/WallpaperContainer.vala"
		_tmp41_ = (GtkMenu*) gtk_menu_new ();
#line 131 "../src/Widgets/WallpaperContainer.vala"
		g_object_ref_sink (_tmp41_);
#line 131 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (self->priv->context_menu);
#line 131 "../src/Widgets/WallpaperContainer.vala"
		self->priv->context_menu = _tmp41_;
#line 132 "../src/Widgets/WallpaperContainer.vala"
		_tmp42_ = self->priv->context_menu;
#line 132 "../src/Widgets/WallpaperContainer.vala"
		_tmp43_ = _data1_->move_to_trash;
#line 132 "../src/Widgets/WallpaperContainer.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp42_, _tmp43_);
#line 133 "../src/Widgets/WallpaperContainer.vala"
		_tmp44_ = self->priv->context_menu;
#line 133 "../src/Widgets/WallpaperContainer.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp44_);
#line 117 "../src/Widgets/WallpaperContainer.vala"
		block1_data_unref (_data1_);
#line 117 "../src/Widgets/WallpaperContainer.vala"
		_data1_ = NULL;
#line 1459 "WallpaperContainer.c"
	}
#line 136 "../src/Widgets/WallpaperContainer.vala"
	g_signal_connect_object ((GtkFlowBoxChild*) self, "activate", (GCallback) __wallpaper_container___lambda9__gtk_flow_box_child_activate, self, 0);
#line 140 "../src/Widgets/WallpaperContainer.vala"
	_tmp45_ = event_box;
#line 140 "../src/Widgets/WallpaperContainer.vala"
	g_signal_connect_object ((GtkWidget*) _tmp45_, "button-press-event", (GCallback) _wallpaper_container_show_context_menu_gtk_widget_button_press_event, self, 0);
#line 1467 "WallpaperContainer.c"
	{
		const gchar* _tmp46_;
#line 143 "../src/Widgets/WallpaperContainer.vala"
		_tmp46_ = self->priv->_uri;
#line 143 "../src/Widgets/WallpaperContainer.vala"
		if (_tmp46_ != NULL) {
#line 1474 "WallpaperContainer.c"
			gboolean _tmp47_ = FALSE;
			const gchar* _tmp48_;
#line 144 "../src/Widgets/WallpaperContainer.vala"
			_tmp48_ = self->priv->_thumb_path;
#line 144 "../src/Widgets/WallpaperContainer.vala"
			if (_tmp48_ != NULL) {
#line 1481 "WallpaperContainer.c"
				gboolean _tmp49_;
#line 144 "../src/Widgets/WallpaperContainer.vala"
				_tmp49_ = self->priv->_thumb_valid;
#line 144 "../src/Widgets/WallpaperContainer.vala"
				_tmp47_ = _tmp49_;
#line 1487 "WallpaperContainer.c"
			} else {
#line 144 "../src/Widgets/WallpaperContainer.vala"
				_tmp47_ = FALSE;
#line 1491 "WallpaperContainer.c"
			}
#line 144 "../src/Widgets/WallpaperContainer.vala"
			if (_tmp47_) {
#line 145 "../src/Widgets/WallpaperContainer.vala"
				wallpaper_container_update_thumb (self, NULL, NULL);
#line 1497 "WallpaperContainer.c"
			} else {
#line 147 "../src/Widgets/WallpaperContainer.vala"
				wallpaper_container_generate_and_load_thumb (self);
#line 1501 "WallpaperContainer.c"
			}
		} else {
			GdkPixbuf* _tmp50_;
			GdkPixbuf* _tmp51_;
			GraniteAsyncImage* _tmp52_;
			GdkPixbuf* _tmp53_;
#line 150 "../src/Widgets/WallpaperContainer.vala"
			_tmp50_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, FALSE, 8, WALLPAPER_CONTAINER_THUMB_WIDTH * self->priv->scale, WALLPAPER_CONTAINER_THUMB_HEIGHT * self->priv->scale);
#line 150 "../src/Widgets/WallpaperContainer.vala"
			_tmp51_ = _tmp50_;
#line 150 "../src/Widgets/WallpaperContainer.vala"
			wallpaper_container_set_thumb (self, _tmp51_);
#line 150 "../src/Widgets/WallpaperContainer.vala"
			_g_object_unref0 (_tmp51_);
#line 151 "../src/Widgets/WallpaperContainer.vala"
			_tmp52_ = self->priv->image;
#line 151 "../src/Widgets/WallpaperContainer.vala"
			_tmp53_ = self->priv->_thumb;
#line 151 "../src/Widgets/WallpaperContainer.vala"
			g_object_set ((GtkImage*) _tmp52_, "gicon", (GIcon*) _tmp53_, NULL);
#line 1522 "WallpaperContainer.c"
		}
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* e = NULL;
		GError* _tmp54_;
		const gchar* _tmp55_;
#line 142 "../src/Widgets/WallpaperContainer.vala"
		e = _inner_error0_;
#line 142 "../src/Widgets/WallpaperContainer.vala"
		_inner_error0_ = NULL;
#line 154 "../src/Widgets/WallpaperContainer.vala"
		_tmp54_ = e;
#line 154 "../src/Widgets/WallpaperContainer.vala"
		_tmp55_ = _tmp54_->message;
#line 154 "../src/Widgets/WallpaperContainer.vala"
		g_critical ("WallpaperContainer.vala:154: Failed to load wallpaper thumbnail: %s", _tmp55_);
#line 155 "../src/Widgets/WallpaperContainer.vala"
		_g_error_free0 (e);
#line 155 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (event_box);
#line 155 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (overlay);
#line 155 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (check);
#line 155 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (provider);
#line 155 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (style_context);
#line 155 "../src/Widgets/WallpaperContainer.vala"
		return obj;
#line 1555 "WallpaperContainer.c"
	}
	__finally8:
#line 142 "../src/Widgets/WallpaperContainer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 142 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (event_box);
#line 142 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (overlay);
#line 142 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (check);
#line 142 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (provider);
#line 142 "../src/Widgets/WallpaperContainer.vala"
		_g_object_unref0 (style_context);
#line 142 "../src/Widgets/WallpaperContainer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 142 "../src/Widgets/WallpaperContainer.vala"
		g_clear_error (&_inner_error0_);
#line 1574 "WallpaperContainer.c"
	}
#line 73 "../src/Widgets/WallpaperContainer.vala"
	_g_object_unref0 (event_box);
#line 73 "../src/Widgets/WallpaperContainer.vala"
	_g_object_unref0 (overlay);
#line 73 "../src/Widgets/WallpaperContainer.vala"
	_g_object_unref0 (check);
#line 73 "../src/Widgets/WallpaperContainer.vala"
	_g_object_unref0 (provider);
#line 73 "../src/Widgets/WallpaperContainer.vala"
	_g_object_unref0 (style_context);
#line 73 "../src/Widgets/WallpaperContainer.vala"
	return obj;
#line 1588 "WallpaperContainer.c"
}

static void
wallpaper_container_class_init (WallpaperContainerClass * klass,
                                gpointer klass_data)
{
#line 21 "../src/Widgets/WallpaperContainer.vala"
	wallpaper_container_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Widgets/WallpaperContainer.vala"
	g_type_class_adjust_private_offset (klass, &WallpaperContainer_private_offset);
#line 21 "../src/Widgets/WallpaperContainer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_wallpaper_container_get_property;
#line 21 "../src/Widgets/WallpaperContainer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_wallpaper_container_set_property;
#line 21 "../src/Widgets/WallpaperContainer.vala"
	G_OBJECT_CLASS (klass)->constructor = wallpaper_container_constructor;
#line 21 "../src/Widgets/WallpaperContainer.vala"
	G_OBJECT_CLASS (klass)->finalize = wallpaper_container_finalize;
#line 21 "../src/Widgets/WallpaperContainer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLPAPER_CONTAINER_THUMB_PATH_PROPERTY, wallpaper_container_properties[WALLPAPER_CONTAINER_THUMB_PATH_PROPERTY] = g_param_spec_string ("thumb-path", "thumb-path", "thumb-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 21 "../src/Widgets/WallpaperContainer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLPAPER_CONTAINER_THUMB_VALID_PROPERTY, wallpaper_container_properties[WALLPAPER_CONTAINER_THUMB_VALID_PROPERTY] = g_param_spec_boolean ("thumb-valid", "thumb-valid", "thumb-valid", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../src/Widgets/WallpaperContainer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLPAPER_CONTAINER_URI_PROPERTY, wallpaper_container_properties[WALLPAPER_CONTAINER_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../src/Widgets/WallpaperContainer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLPAPER_CONTAINER_THUMB_PROPERTY, wallpaper_container_properties[WALLPAPER_CONTAINER_THUMB_PROPERTY] = g_param_spec_object ("thumb", "thumb", "thumb", gdk_pixbuf_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Widgets/WallpaperContainer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLPAPER_CONTAINER_CHECKED_PROPERTY, wallpaper_container_properties[WALLPAPER_CONTAINER_CHECKED_PROPERTY] = g_param_spec_boolean ("checked", "checked", "checked", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Widgets/WallpaperContainer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLPAPER_CONTAINER_SELECTED_PROPERTY, wallpaper_container_properties[WALLPAPER_CONTAINER_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Widgets/WallpaperContainer.vala"
	wallpaper_container_signals[WALLPAPER_CONTAINER_TRASH_SIGNAL] = g_signal_new ("trash", TYPE_WALLPAPER_CONTAINER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1621 "WallpaperContainer.c"
}

static void
wallpaper_container_instance_init (WallpaperContainer * self,
                                   gpointer klass)
{
#line 21 "../src/Widgets/WallpaperContainer.vala"
	self->priv = wallpaper_container_get_instance_private (self);
#line 1630 "WallpaperContainer.c"
}

static void
wallpaper_container_finalize (GObject * obj)
{
	WallpaperContainer * self;
#line 21 "../src/Widgets/WallpaperContainer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WALLPAPER_CONTAINER, WallpaperContainer);
#line 27 "../src/Widgets/WallpaperContainer.vala"
	_g_object_unref0 (self->priv->card_box);
#line 28 "../src/Widgets/WallpaperContainer.vala"
	_g_object_unref0 (self->priv->context_menu);
#line 29 "../src/Widgets/WallpaperContainer.vala"
	_g_object_unref0 (self->priv->check_revealer);
#line 30 "../src/Widgets/WallpaperContainer.vala"
	_g_object_unref0 (self->priv->image);
#line 32 "../src/Widgets/WallpaperContainer.vala"
	_g_free0 (self->priv->_thumb_path);
#line 34 "../src/Widgets/WallpaperContainer.vala"
	_g_free0 (self->priv->_uri);
#line 35 "../src/Widgets/WallpaperContainer.vala"
	_g_object_unref0 (self->priv->_thumb);
#line 21 "../src/Widgets/WallpaperContainer.vala"
	G_OBJECT_CLASS (wallpaper_container_parent_class)->finalize (obj);
#line 1655 "WallpaperContainer.c"
}

GType
wallpaper_container_get_type (void)
{
	static volatile gsize wallpaper_container_type_id__volatile = 0;
	if (g_once_init_enter (&wallpaper_container_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (WallpaperContainerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wallpaper_container_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WallpaperContainer), 0, (GInstanceInitFunc) wallpaper_container_instance_init, NULL };
		GType wallpaper_container_type_id;
		wallpaper_container_type_id = g_type_register_static (gtk_flow_box_child_get_type (), "WallpaperContainer", &g_define_type_info, 0);
		WallpaperContainer_private_offset = g_type_add_instance_private (wallpaper_container_type_id, sizeof (WallpaperContainerPrivate));
		g_once_init_leave (&wallpaper_container_type_id__volatile, wallpaper_container_type_id);
	}
	return wallpaper_container_type_id__volatile;
}

static void
_vala_wallpaper_container_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	WallpaperContainer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WALLPAPER_CONTAINER, WallpaperContainer);
#line 21 "../src/Widgets/WallpaperContainer.vala"
	switch (property_id) {
#line 21 "../src/Widgets/WallpaperContainer.vala"
		case WALLPAPER_CONTAINER_THUMB_PATH_PROPERTY:
#line 21 "../src/Widgets/WallpaperContainer.vala"
		g_value_set_string (value, wallpaper_container_get_thumb_path (self));
#line 21 "../src/Widgets/WallpaperContainer.vala"
		break;
#line 21 "../src/Widgets/WallpaperContainer.vala"
		case WALLPAPER_CONTAINER_THUMB_VALID_PROPERTY:
#line 21 "../src/Widgets/WallpaperContainer.vala"
		g_value_set_boolean (value, wallpaper_container_get_thumb_valid (self));
#line 21 "../src/Widgets/WallpaperContainer.vala"
		break;
#line 21 "../src/Widgets/WallpaperContainer.vala"
		case WALLPAPER_CONTAINER_URI_PROPERTY:
#line 21 "../src/Widgets/WallpaperContainer.vala"
		g_value_set_string (value, wallpaper_container_get_uri (self));
#line 21 "../src/Widgets/WallpaperContainer.vala"
		break;
#line 21 "../src/Widgets/WallpaperContainer.vala"
		case WALLPAPER_CONTAINER_THUMB_PROPERTY:
#line 21 "../src/Widgets/WallpaperContainer.vala"
		g_value_set_object (value, wallpaper_container_get_thumb (self));
#line 21 "../src/Widgets/WallpaperContainer.vala"
		break;
#line 21 "../src/Widgets/WallpaperContainer.vala"
		case WALLPAPER_CONTAINER_CHECKED_PROPERTY:
#line 21 "../src/Widgets/WallpaperContainer.vala"
		g_value_set_boolean (value, wallpaper_container_get_checked (self));
#line 21 "../src/Widgets/WallpaperContainer.vala"
		break;
#line 21 "../src/Widgets/WallpaperContainer.vala"
		case WALLPAPER_CONTAINER_SELECTED_PROPERTY:
#line 21 "../src/Widgets/WallpaperContainer.vala"
		g_value_set_boolean (value, wallpaper_container_get_selected (self));
#line 21 "../src/Widgets/WallpaperContainer.vala"
		break;
#line 1718 "WallpaperContainer.c"
		default:
#line 21 "../src/Widgets/WallpaperContainer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/WallpaperContainer.vala"
		break;
#line 1724 "WallpaperContainer.c"
	}
}

static void
_vala_wallpaper_container_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	WallpaperContainer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WALLPAPER_CONTAINER, WallpaperContainer);
#line 21 "../src/Widgets/WallpaperContainer.vala"
	switch (property_id) {
#line 21 "../src/Widgets/WallpaperContainer.vala"
		case WALLPAPER_CONTAINER_THUMB_PATH_PROPERTY:
#line 21 "../src/Widgets/WallpaperContainer.vala"
		wallpaper_container_set_thumb_path (self, g_value_get_string (value));
#line 21 "../src/Widgets/WallpaperContainer.vala"
		break;
#line 21 "../src/Widgets/WallpaperContainer.vala"
		case WALLPAPER_CONTAINER_THUMB_VALID_PROPERTY:
#line 21 "../src/Widgets/WallpaperContainer.vala"
		wallpaper_container_set_thumb_valid (self, g_value_get_boolean (value));
#line 21 "../src/Widgets/WallpaperContainer.vala"
		break;
#line 21 "../src/Widgets/WallpaperContainer.vala"
		case WALLPAPER_CONTAINER_URI_PROPERTY:
#line 21 "../src/Widgets/WallpaperContainer.vala"
		wallpaper_container_set_uri (self, g_value_get_string (value));
#line 21 "../src/Widgets/WallpaperContainer.vala"
		break;
#line 21 "../src/Widgets/WallpaperContainer.vala"
		case WALLPAPER_CONTAINER_THUMB_PROPERTY:
#line 21 "../src/Widgets/WallpaperContainer.vala"
		wallpaper_container_set_thumb (self, g_value_get_object (value));
#line 21 "../src/Widgets/WallpaperContainer.vala"
		break;
#line 21 "../src/Widgets/WallpaperContainer.vala"
		case WALLPAPER_CONTAINER_CHECKED_PROPERTY:
#line 21 "../src/Widgets/WallpaperContainer.vala"
		wallpaper_container_set_checked (self, g_value_get_boolean (value));
#line 21 "../src/Widgets/WallpaperContainer.vala"
		break;
#line 21 "../src/Widgets/WallpaperContainer.vala"
		case WALLPAPER_CONTAINER_SELECTED_PROPERTY:
#line 21 "../src/Widgets/WallpaperContainer.vala"
		wallpaper_container_set_selected (self, g_value_get_boolean (value));
#line 21 "../src/Widgets/WallpaperContainer.vala"
		break;
#line 1774 "WallpaperContainer.c"
		default:
#line 21 "../src/Widgets/WallpaperContainer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/WallpaperContainer.vala"
		break;
#line 1780 "WallpaperContainer.c"
	}
}

